## Copyright (C) 2002, 2003 Red Hat, Inc.
## Copyright (C) 2002, 2003 Than Ngo <than@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

PROGNAME = 'system-switch-mail'
SWITCHMAILDIR = '/usr/share/' + PROGNAME + '/'
TITLE = PROGNAME
COPYRIGHT = 'Copyright (C) 2002-2006 Red Hat, Inc.'
AUTORS = ['Than Ngo <than@redhat.com>']
VERSION = '0.5.25-11'
GLADEPATH = ''
TRUE = (1==1)
FALSE = not TRUE

import re
import traceback
import sys
import os
import os.path
import shutil
import string
import gettext

SENDMAIL =  0 
POSTFIX = 1
EXIM =  2
MTA = ['Sendmail', 'Postfix', 'Exim']
MTA_PATH = '/etc/alternatives/mta'

##
## I18N
##
gettext.bindtextdomain(PROGNAME, '/usr/share/locale')
gettext.textdomain(PROGNAME)
_ = gettext.gettext

WARNING_TEXT = _('Mail Transport Agent is not installed on system.\n'
                 'Please install it and restart this tool again.')

INFO_TEXT = _("This software is distributed under the GPL. Please Report bugs to Red Hat's Bug Tracking System: http://bugzilla.redhat.com/")


INFO_TEXT1 = _('Your MTA configuration has succesfully been updated.\n')

TEXT = _('The Mail Transport Agent Switcher is a tool which enables users to easily switch between various Mail Transport Agent that they have installed.\n\nPlease choose your Mail transport agent.')

def switch(i):
    if i == SENDMAIL:
        os.system('/usr/sbin/alternatives --set mta /usr/sbin/sendmail.sendmail')
        os.system('/sbin/service postfix stop 2>/dev/null >/dev/null')
        os.system('/sbin/service exim stop 2>/dev/null >/dev/null')
        os.system('/sbin/service sendmail start 2>/dev/null >/dev/null')
    elif i == POSTFIX:
        os.system('/usr/sbin/alternatives --set mta /usr/sbin/sendmail.postfix')
        os.system('/sbin/service sendmail stop 2>/dev/null >/dev/null')
        os.system('/sbin/service exim stop 2>/dev/null >/dev/null')
        os.system('/sbin/service postfix start 2>/dev/null >/dev/null')
    elif i == EXIM:
        os.system('/usr/sbin/alternatives --set mta /usr/sbin/sendmail.exim')
        os.system('/sbin/service postfix stop 2>/dev/null >/dev/null')
        os.system('/sbin/service sendmail stop 2>/dev/null >/dev/null')
        os.system('/sbin/service exim start 2>/dev/null >/dev/null')

def get_mta():
    mta_list = []
    for mta in MTA:
        if os.system('/bin/rpm -q ' + string.lower(mta) + '>/dev/null 2>&1') == 0:
            mta_list.append(mta)

    return(mta_list)

def get_default_mta(mta_list):
    if os.path.exists(MTA_PATH) and os.path.islink(MTA_PATH):
        default_mta = os.readlink(MTA_PATH)
        if default_mta == '/usr/sbin/sendmail.sendmail':
            return MTA[SENDMAIL]
        elif default_mta == '/usr/sbin/sendmail.postfix':
            return MTA[POSTFIX]
        elif default_mta == '/usr/sbin/sendmail.exim':
            return MTA[EXIM]

    return mta_list[SENDMAIL]
